unit umodule;

//{$mode objfpc}{$H+}
{$mode delphi}{$H+}

interface

uses
  //SharedMemory,
  Forms,Classes, SysUtils,dynlibs,Dialogs;
//информация о модуле
type
  TmoduleInfo = record
    Name:PChar;
    TypePlugin:integer;//1-gui,2-console
end;
  // описания типов функций модуля
type
  TGetModuleInfo=procedure(info:integer);stdcall;
  TInitialize=procedure;stdcall;
  TRun=procedure;stdcall;
  TTerminate=procedure;stdcall;
  // непосресдвенно сам класс

    { TModule }

    TModule=class
    private
      ModuleFile:wideString;  //имя файла
      MHandle:TLibHandle;   // дескриптор библиотеки
      FModuleInfo:TModuleInfo;  // информация о модуле
      // адреса функций плагина
      FGetModuleInfo:TGetModuleInfo; // функция получения информации о модуле
      FInitialize:TInitialize;  // процедура инициализации
      FRun:TRun;  // процедура запуска
      FTerminate:TTerminate;  // процедура останова
      //FSetData:TSetData;  // процедура передачи данных
    public
      constructor Create(AFileName:PChar;var IsValidModule:Boolean=false);
      destructor Destroy;override;
      // вызов функций плагина
      function GetModuleInfo:String;
      procedure Initialize;
      procedure Run;
      procedure Terminate;
     // procedure SetData(Kind:TDataKind;const Buffer;Size:Integer);
      // свойства плагина
      property FileName:wideString read ModuleFile;
      property Handle:TLibHandle read MHandle;
      //property ModuleInfo:WideString read FGetModuleInfo;
    end;

implementation

{ TModule }

constructor TModule.Create(AFileName:PChar; var IsValidModule:Boolean=false);
begin
 ModuleFile:=AFileName;
 MHandle:=LoadLibrary(AFileName);
 if(MHandle<>0)then
  begin
   IsValidModule:=true;
   @FInitialize:=GetProcedureAddress(MHandle,'Initialize');
   @FRun:=GetProcedureAddress(MHandle,'Run');
   @FTerminate:=GetProcedureAddress(MHandle,'Terminate');
   @FGetModuleInfo:=GetProcedureAddress(MHandle,'ModuleInfo');
  end;
end;

destructor TModule.Destroy;
begin
 if(UnloadLibrary(MHandle))then inherited Destroy;
end;

function TModule.GetModuleInfo:string;
var info:integer;
  t:^integer;
begin
// try
 info:=121452;
 //t:=@info;
 //ShowMessage(inttostr(t^));
 if(@FGetModuleInfo<>nil)then FGetModuleInfo(info) else ShowMessage('1');
// except
// ShowMessage('2');
//end;
end;

procedure TModule.Initialize;
begin
 if(@FInitialize<>nil)then FInitialize else showmessage('no init');
end;

procedure TModule.Run;
begin
if(@FRun<>nil)then FRun else showmessage('no run');
end;

procedure TModule.Terminate;
begin
 if(@FTerminate<>nil)then FTerminate else showmessage('no terminate');
end;

end.

